;; executed once when we press the setup button
to setup
  ;; clear all turtles and patches                               
  ca   
  ;; create 20 turtles           
  crt 20            
  ask turtles 
    ;; each turtle sets its color to white
    [set color white]
  ask patches 
    ;; patches set their color to their x-coordinate
    [set pcolor pxcor]                   
end

;; forever button; thus, continuously executed
to move-turtles                         
  ask turtles  [
  ;; ask each turtle to change its color and move forward one
  set color (color - 1)     
  fd 1 wait 0.25
  ]     
end                                     

;; forever button; thus, continuously executed
to recolor-patches                                     
  ask patches
    ;; ask each patch to change its color
    [set pcolor (pcolor - 1)]      
  ;; wait a bit                      
  wait 2
end


;; This model was created as part of the project: 
;; PARTICIPATORY SIMULATIONS: NETWORK-BASED DESIGN FOR SYSTEMS LEARNING IN CLASSROOMS.
;; The project gratefully acknowledges the support of the National Science Foundation
;; (REPP Program) -- grant numbers RED #9552950 and REC #9632612.

;; Copyright 1999 by Uri Wilensky. All rights reserved.
;; Converted to NetLogo from StarLogoT, 2001

;; Permission to use, copy, or modify this software and its documentation
;; is hereby granted, provided that this copyright notice and the original authors'
;; names appear on all copies and supporting documentation. For any other 
;; uses of this software, in original or modified form, including but not
;; limited to distribution in whole or in part, specific prior permission 
;; must be obtained from Uri Wilensky. These programs shall not be used, 
;; rewritten, or adapted as the basis of a commercial software or hardware
;; product without first obtaining appropriate licenses from Uri Wilensky.

;; We make no representations about the suitability of this software for any purpose. 
;; It is provided "as is" without express or implied warranty.
@#$#@#$#@
CC-WINDOW
11
149
308
324
Command Center

BUTTON
74
46
129
76
setup
setup
NIL
1
T
OBSERVER

BUTTON
166
46
273
77
move-turtles
move-turtles
T
1
T
OBSERVER

BUTTON
164
98
279
128
recolor-patches
recolor-patches
T
1
T
OBSERVER

GRAPHICS-WINDOW
321
10
621
310
12
12
12.0
1

@#$#@#$#@
WHAT IS IT?
-----------
This demo shows how to control agentsets using agentset commands. Agentsets are exactly what the name implies -- sets of agents. In NetLogo these agents are turtles and patches. The demo shows how to control all turtles simultaneously using the "ask turtles" command, and how to control all patches simultaneously using the "ask patches" command.

The agentset can also be limited by conditions.  For example, "ask turtles with [ycor > 0] [ ... ]" would only control turtles on or above the x-axis.  Try it! 
@#$#@#$#@
arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150 

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45 

default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250 

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135 

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150 

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105 

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110 
Polygon -7566196 true true 216 83 267 123 248 143 215 107 
Polygon -7566196 true true 167 163 145 234 183 234 183 163 
Polygon -7566196 true true 195 163 195 233 227 233 206 159 

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30 
Polygon -8716033 true false 195 75 195 120 240 120 240 75 
Polygon -8716033 true false 195 225 195 180 240 180 240 225 

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165 
Polygon -8716033 true false 210 210 195 225 180 210 
Polygon -8716033 true false 120 210 105 225 90 210 

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165 
Polygon -8716033 true false 90 210 105 225 120 210 
Polygon -8716033 true false 180 210 195 225 210 210 

circle
true
0
Circle -7566196 true true 35 35 230

@#$#@#$#@
NetLogo 1.0 Beta 5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
