to setup                
  ca                          ; clears all patch and turtle variables, and sets the graphics window to black.
  create-turtles 500          ; creates 500 turtles in the center of the screen
  ask turtles [
    rt random 360             ; sets heading of turtles to a random direction
    fd random screen-edge-x   ; each turtle moves forward on its heading a random integer value
    ]                         ; between 0 and half of the size of the screen.
end

to go
  ask turtles [
    set heading 270
    fd 1
    ; Each turtle sets its color according to its x-coordinate.
    ; As its x-coordinate approaches the left side of the screen, 
    ; the turtle becomes darker.
    ; As its x-coordinate moves to the right side of the screen, 
    ; the turtle becomes lighter
    set color scale-color shading xcor (0 - screen-edge-x) (screen-edge-x)
    ]
end


; This model was created as part of the project: CONNECTED MATHEMATICS:
; MAKING SENSE OF COMPLEX PHENOMENA THROUGH BUILDING OBJECT-BASED PARALLEL
; MODELS (OBPML)
; The project gratefully acknowledges the support of the National Science
; Foundation (Applications of Advanced Technologies Program) -- grant numbers
; RED #9552950 and REC #9632612.
; 
; Converted from StarLogoT to NetLogo, 2001
; Copyright 1999  by Uri Wilensky. All rights reserved.
; 
; Permission to use, copy, or modify this software and its documentation for
; educational and research purposes only and without fee is hereby granted,
; provided that this copyright notice and the original authors' names appear
; on all copies and supporting documentation. For any other uses of this
; software, in original or modified form, including but not limited to
; distribution in whole or in part, specific prior permission must be
; obtained from Uri Wilensky. These programs shall not be used, rewritten, or
; adapted as the basis of a commercial software or hardware product without
; first obtaining appropriate licenses from Uri Wilensky. We make no
; representations about the suitability of this software for any purpose. It
; is provided "as is" without express or implied warranty.
@#$#@#$#@
CC-WINDOW
11
146
308
321
Command Center

BUTTON
83
32
138
62
NIL
setup
NIL
1
T
OBSERVER

BUTTON
165
32
220
62
go
go
T
1
T
OBSERVER

SLIDER
106
93
213
117
shading
shading
0.0
140.0
105.0
1.0
1

GRAPHICS-WINDOW
321
10
621
310
12
12
12.0
1

@#$#@#$#@
WHAT IS IT?
-----------
This code example demonstrates the scale-color reporter.  As a turtle's x-coordinate becomes larger,the turtle acquires a brighter color. Similarly, as a turtle's x-coordinate becomes smaller, the turtle acquires a darker shade.  The center of the graphics window is (0,0).
@#$#@#$#@
arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150 

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45 

default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250 

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135 

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150 

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105 

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110 
Polygon -7566196 true true 216 83 267 123 248 143 215 107 
Polygon -7566196 true true 167 163 145 234 183 234 183 163 
Polygon -7566196 true true 195 163 195 233 227 233 206 159 

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30 
Polygon -8716033 true false 195 75 195 120 240 120 240 75 
Polygon -8716033 true false 195 225 195 180 240 180 240 225 

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165 
Polygon -8716033 true false 210 210 195 225 180 210 
Polygon -8716033 true false 120 210 105 225 90 210 

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165 
Polygon -8716033 true false 90 210 105 225 120 210 
Polygon -8716033 true false 180 210 195 225 210 210 

circle
true
0
Circle -7566196 true true 35 35 230

@#$#@#$#@
NetLogo 1.0 Beta 5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
